/* Tsinghuaeolus soccer client for Robocup2001
 *
 * Computer Science Department
 * State Key Lab of Intelligent Technology and Systems
 * Tsinghua University
 * 
 * Copyright (C) 2001 Tsinghuaeolus
 * Team Leader : Lishi
 * Team memebers : ChenJiang, YaoJinyi, CaiYunpeng
 *
 * We thank CMU for CMU98 was used for reference in our initial stage.
 *
 * You may copy and distribute this program freely as long as you retain this notice.
 * If you make any changes or have any comments we would appreciate a message to yjy01@mails.tsinghua.edu.cn.
 * For more information, please see http://www.lits.tsinghua.edu.cn/RoboCup
 */

#ifndef _RSA
#define _RSA

class RSAEncrypt{
private:
	unsigned _int64 L,N,ONE;
	_int64 ZZXC(_int64 m,_int64);
	void mutiple(unsigned _int64,unsigned _int64,unsigned _int64*);
	unsigned _int64 Model_mutiple(unsigned _int64 m,unsigned _int64 n);
public:
	RSAEncrypt();
	RSAEncrypt(unsigned _int64 m, unsigned _int64 n = 1);
	void setkey(unsigned _int64 m, unsigned _int64 n = 1);
	unsigned _int64 Exponent(unsigned _int64 m,unsigned _int64 e);
	_int64 GenerateKey(unsigned _int64);
};

#endif